=== src/doc/CMakeLists.txt ===
# Aseprite Document Library
# Copyright (C) 2014 David Capello

add_library(doc-lib
  context.cpp
  document.cpp
  documents.cpp
  object.cpp
  sprites.cpp)
