=== src/gfx/CMakeLists.txt ===
# Aseprite
# Copyright (C) 2001-2014  David Capello

add_library(gfx-lib
  hsv.cpp
  packing_rects.cpp
  region.cpp
  rgb.cpp
  transformation.cpp)
