=== src/raster/CMakeLists.txt ===
# Aseprite
# Copyright (C) 2001-2014  David Capello

add_library(raster-lib
  algo.cpp
  algo_polygon.cpp
  algofill.cpp
  algorithm/flip_image.cpp
  algorithm/resize_image.cpp
  algorithm/shrink_bounds.cpp
  blend.cpp
  brush.cpp
  cel.cpp
  cel_io.cpp
  color_scales.cpp
  conversion_alleg.cpp
  conversion_she.cpp
  dirty.cpp
  dirty_io.cpp
  file/col_file.cpp
  file/gpl_file.cpp
  image.cpp
  image_io.cpp
  images_collector.cpp
  layer.cpp
  layer_index.cpp
  layer_io.cpp
  mask.cpp
  mask_io.cpp
  object.cpp
  palette.cpp
  palette_io.cpp
  primitives.cpp
  quantization.cpp
  rgbmap.cpp
  rotate.cpp
  rotsprite.cpp
  sprite.cpp
  stock.cpp)
