=== debian/changelog ===
aseprite (1.0.9+ds-3.2) unstable; urgency=medium

  * Non-maintainer upload as team member.
  * NMU chosen to avoid interfering with new upstream version in git)
  * Fix "FTBFS with libpng16", patch libpng16.patch (Closes: #741891)

 -- Tobias Frost <tobi@debian.org>  Sat, 23 Jan 2016 15:55:11 +0100

aseprite (1.0.9+ds-3.1) unstable; urgency=medium

  * Non maintainer upload.
  * Build using giflib5. Closes: #803276.

 -- Matthias Klose <doko@debian.org>  Wed, 16 Dec 2015 05:29:03 +0100

aseprite (1.0.9+ds-3) unstable; urgency=medium

  * debian/patches/dont_use_x86_assembly.patch:
    - Added. Fixes FTBFS with GCC 5. (Closes: #790478)

 -- Tobias Hansen <thansen@debian.org>  Wed, 15 Jul 2015 15:04:27 +0200

aseprite (1.0.9+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Tobias Hansen <thansen@debian.org>  Sat, 16 May 2015 21:41:01 +0200

aseprite (1.0.9+ds-1) experimental; urgency=medium

  * New upstream release.
  * Add patch to allow window resizing in options dialog.
  * Add new dependency libpixman-1-dev.
  * Add patch to find libpixman.
  * Refresh patches.

 -- Tobias Hansen <thansen@debian.org>  Sat, 14 Mar 2015 18:08:26 +0100
