=== debian/watch ===
version=3
opts=\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/<project>-$1\.tar\.gz/,\
dversionmangle=s/\+(debian|dfsg|ds|deb|repack)(\.\d+)?$//\
  https://github.com/aseprite/aseprite/tags .*/v?(\d\S*)\.tar\.gz
